import 'package:flutter/cupertino.dart';
import 'package:nui_core/code/nui_code_util.dart';
import 'package:nui_core/ui/component/listview/nui_list_interface.dart';
import 'package:nui_core/ui/component/listview/nui_list_item_repo.dart';
import 'package:nui_core/ui/component/listview/nui_listview_bloc.dart';
import '../nui_shader_mask.dart';
import 'nui_listview_builder.dart';
import 'nui_listview_functions.dart';

@Deprecated("NUIGrid is deprecated, use NUIHeaderGrid instead")
class NUIGrid<T, C> extends NUIAnimatedListInterface<T, C> {
  NUIGrid({
    @required NUIListViewBloc<T, C> bloc,
    @required NUIListItemRepository repo,
    @required List<T> initialList,
    @required OnListItemClickListener clickListener,
    bool shrinkWrap: false,
    double startDivider,
    double endDivider,
    double middleDivider,
    ListFixedItemGetter fixedFirstItem,
    ListFixedItemGetter fixedLastItem,
    Axis orientation: Axis.vertical,
    EdgeInsets padding,
    bool enablePagination: false,
    bool enableSwipeRefresh: false,
    int minimumPaginateCount: 5,
    NUILoadingListItem skeletalInflater,
    NUILoadingListItem paginationInflater,
    ListShadowInflater shadowInflater,
    ListPlaceHolderInflater placeHolder,
    ListErrorHolderInflater errorHolder,
    NUIListScrollListener scrollListener,
    int skeletalCount: 1,
    NUIListController controller,
    NUIShaderMaskType shaderType,
    ScrollPhysics scrollPhysics,
    Map<String, dynamic> checkedMap,
    Map<String, dynamic> configMap,
    @required this.gridDelegate,
  }) : super(
      repo: repo,
      initialList: initialList,
      orientation: orientation,
      padding: padding,
      shrinkWrap: shrinkWrap,
      startDivider: startDivider,
      endDivider: endDivider,
      middleDivider: middleDivider,
      fixedFirstItem: fixedFirstItem,
      shaderType: shaderType,
      fixedLastItem: fixedLastItem,
      checkedMap: checkedMap,
      configMap: configMap,
      clickListener: clickListener,
      skeletalCount: skeletalCount,
      errorHolder: errorHolder,
      scrollListener: scrollListener,
      placeHolder: placeHolder,
      controller: controller,
      skeletalInflater: skeletalInflater,
      paginationInflater: paginationInflater,
      scrollPhysics: scrollPhysics,
      enablePagination: enablePagination,
      enableSwipeRefresh: enableSwipeRefresh,
      minimumPaginateCount: minimumPaginateCount,
      skipAnimation: true,
      bloc: bloc,
      itemAnimation : NUIListItemAnimation.NONE
  );

  final SliverGridDelegateWithFixedCrossAxisCount gridDelegate;

  @override
  _NUIGridState<T, C> createState() => _NUIGridState<T, C>();
}

class _NUIGridState<T, C> extends NUIAnimatedListState<T, C, NUIGrid<T, C>> {
  @override
  Widget getListView(int initialCount){
    logNUI("NUIGrid", "Building animated list view with count : ${items.length}");
    return GridView.builder(
        physics: widget.scrollPhysics ?? NUICustomScrollPhysics(),
        padding: widget.padding,
        scrollDirection: widget.orientation,
        shrinkWrap: widget.shrinkWrap ?? false,
        itemCount: items.length,
        gridDelegate: widget.gridDelegate ?? SliverGridDelegateWithFixedCrossAxisCount(crossAxisCount: 2),
        itemBuilder: (context, position){
          if(position < items.length) {
            return renderItem(context, position);
          }
          return null;
        });
  }
}



