import 'package:nui_core/nui_core.dart';
import 'package:nui_core/ui/component/nui_gradient_color_selection.dart';

import 'nui_list_models.dart';

class NUIInternalListItemRepo extends NUIListItemRepository{
  @override
  void registerListItems(){
    registerItem(NUIListItem(entityClass: NUIGradientColorSelection, inflater: (dynamic data, int position, NUIListActionController handler) => NUIGradientColorSelectionItem(color: data, handler: handler)));
  }
}

abstract class NUIListItemRepository{
  NUIListItemRepository(){
    registerListItems();
  }

  Map<String, NUIListItem> _cacheMap = Map();
  Map<String, NUIListItem> _repo = Map();

  void registerListItems();

  void registerItem(NUIListItem item){
    _repo[item.entityClass.toString()] = item;
  }

  NUIListItem getItemByClass(Type entityClass){
    NUIListItem item = _cacheMap[entityClass.toString()];
    if(item == null){
      //Not in cache yet, so get from the whole list
      item = _repo[entityClass.toString()];
      _cacheMap[entityClass.toString()] = item;
    }
    return item;
  }

}