import 'dart:developer';

import 'package:flutter/cupertino.dart';

enum FutureState{
  SUCCESS,
  FAILED,
  LOADING
}

class NUIFutureWidget<T> extends StatefulWidget {
  NUIFutureWidget({@required this.futureValue, @required this.callback}){
  }
  final Future<T> futureValue;
  final NUIFutureCallback<T> callback;
  @override
  _NUIFutureWidgetState<T> createState() => _NUIFutureWidgetState<T>();
}

class _NUIFutureWidgetState<T> extends State<NUIFutureWidget<T>> {
  @override
  Widget build(BuildContext context) {
    return FutureBuilder<T>(
      future: widget.futureValue,
      builder: (BuildContext context, AsyncSnapshot<T> snapshot){
        if(snapshot.hasData){
          //Success and obtained data
          return widget.callback(FutureState.SUCCESS, snapshot.data, "Data obtained");
        }
        else if(snapshot.hasError){
          //Failed with error
          return widget.callback(FutureState.FAILED, null, "Failed to obtain data");
        }
        else{
          //Loading in progress
          return widget.callback(FutureState.LOADING, null, "Loading data");
        }
      },
    );
  }
}

typedef NUIFutureCallback<D> = Widget Function(FutureState state, D data, String message);
