import 'package:flutter/cupertino.dart';
import 'package:nui_core/data/nui_data_util.dart';
import 'nui_state_widget.dart';

void updateNUIStackIndex({@required String id, @required int index}){
  if(isNullOrEmpty(id)) return;
  if(index == null) return;

  updateNUIState<int>(id: NUIIndexedStack._getWidgetId(id), update: index);
}

class NUIIndexedStack extends StatefulWidget {
  NUIIndexedStack({@required this.id, this.initialIndex: 0, @required this.children, this.width, this.height});

  static String _getWidgetId(String id){
    return "NUIIndexedStack_$id";
  }

  final String id;
  final int initialIndex;
  final List<Widget> children;
  final double height;
  final double width;
  @override
  _NUIIndexedStackState createState() => _NUIIndexedStackState();
}

class _NUIIndexedStackState extends State<NUIIndexedStack> {
  @override
  Widget build(BuildContext context) {
    return Container(
      width: widget.width,
      height: widget.height,
      child: NUIStateful<int>(
        id: NUIIndexedStack._getWidgetId(widget.id),
        initial: widget.initialIndex ?? 0,
        child: (newIndex) => IndexedStack(
          index: newIndex,
          children: widget.children,
        ),
      ),
    );
  }
}
