import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';

typedef NUIRoute = Widget Function(BuildContext context);

class NUINavigatorPage extends StatelessWidget {
  NUINavigatorPage({@required this.routes, @required this.initialRoute});
  final Map<String, NUIRoute> routes;
  final String initialRoute;
  @override
  Widget build(BuildContext context) {
    return Navigator(
        initialRoute: initialRoute,
        onGenerateRoute: (RouteSettings settings){
          NUIRoute router = routes[settings.name];
          if(router == null) throw Exception("NUINavigatorPage -> Route name of ${settings.name} is not defined");
          return MaterialPageRoute(
              settings: settings,
              builder: (BuildContext context){
                return router(context);
              }
          );
        }
    );
  }
}
