import 'package:flutter/cupertino.dart';
import 'package:nui_core/ui/nui_navigator.dart';
import 'package:nui_core/ui/component/nui_parent_widget.dart';

class NUIWidget extends StatefulWidget {
  NUIWidget(this.view, {this.parent, Key key}) : super(key : key);
  final Widget view;
  final NUIParentWidget parent;
  @override
  _NUIWidgetState createState() => _NUIWidgetState();
}

class _NUIWidgetState extends State<NUIWidget> {
  @override
  Widget build(BuildContext context) {
    return widget.view;
  }

  void open(BuildContext context, Widget page){
    if(widget.parent != null){
      widget.parent.open(page);
    }
    else{
      NUINavigator.push(context, page);
    }
  }

  void exit(BuildContext context){
    if(widget.parent != null){
      widget.parent.exit();
    }
    else{
      NUINavigator.pop(context);
    }
  }
}
