import 'package:url_launcher/url_launcher.dart';

class NUIURLLauncherUtil{
  NUIURLLauncherUtil._builder();

  void launchURL(String url){
    final Uri uri = Uri(
      scheme: "http",
      path: url
    );
    launch(uri.toString());
  }

  void launchEmailURL(String email, {String subject : "", String body: ""}){
    final Uri uri = Uri(
      scheme: "mailto",
      path: email,
      queryParameters: {
        "subject": subject,
        "body": body
      }
    );
    launch(uri.toString());
  }

  void launchPhoneURL(String phone){
    final Uri uri = Uri(
      scheme: "tel",
      path: phone
    );
    launch(uri.toString());
  }

  void launchSMSUrl(String phone, {String subject: "", String body: ""}){
    final Uri uri = Uri(
        scheme: "mailto",
        path: "sms",
        queryParameters: {
          "subject": subject,
          "body": body
        }
    );
    launch(uri.toString());
  }
}