import 'package:permission_handler/permission_handler.dart';

class NUIPermissionUtil{

  static Future<bool> hasPermission(Permission permission) async{
    final status = await permission.status;
    return status.isGranted;
  }

  static Future<bool> requestPermission(Permission permission) async{
    return await permission.request().isGranted;
  }

  static Future<bool> requestPermissions(List<Permission> permissions) async{
    Map<Permission, PermissionStatus> statuses = await permissions.request();
    bool allGranted = true;
    for(PermissionStatus stat in statuses.values){
      allGranted = allGranted && stat.isGranted;
    }
    return allGranted;
  }

  static Future<bool> hasLocationPermission() async{
    return await hasPermission(Permission.location) && await hasPermission(Permission.locationAlways) && await hasPermission(Permission.locationWhenInUse)
        && await Permission.locationWhenInUse.serviceStatus.isEnabled;
  }

}