import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:nui_core/color/nui_colors.dart';

class NUITextUtil{
  static Shadow getTextShadow({Color color: NUIColors.NUIShadowBlackTransparent, double xOffset: 0, double yOffset:0, double blurRadius:2}){
    return Shadow(color: color, offset: Offset(xOffset, yOffset), blurRadius: blurRadius);
  }
}

class NUITextSpan extends StatefulWidget {
  NUITextSpan({@required this.defaultStyle, @required this.spans});
  final TextStyle defaultStyle;
  final List<NUIChildTextSpan> spans;
  @override
  _NUITextSpanState createState() => _NUITextSpanState();
}

class NUIChildTextSpan{
  NUIChildTextSpan({@required this.text, this.style, this.onTap});
  final String text;
  final TextStyle style;
  final GestureTapCallback onTap;
}

class _NUITextSpanState extends State<NUITextSpan> {
  @override
  Widget build(BuildContext context) {
    return RichText(
        text: TextSpan(
          style: widget.defaultStyle,
          children:widget.spans.map((text){
            return TextSpan(
              text: text.text,
              style: text.style,
              recognizer: TapGestureRecognizer()..onTap = () => text.onTap != null ? text.onTap() : null
            );
          }).toList()
        )
    );
  }
}
